//
// PointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PointsAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeDaysDateGet: String { 
        case sundistance = "sunDistance"
        case sunradius = "sunRadius"
        case suntransit = "sunTransit"
        case sunrise = "sunrise"
        case sunset = "sunset"
        case civilrise = "civilRise"
        case civilset = "civilSet"
        case nauticalrise = "nauticalRise"
        case nauticalset = "nauticalSet"
        case astrorise = "astroRise"
        case astroset = "astroSet"
        case moondistance = "moonDistance"
        case moonradius = "moonRadius"
        case moonrise = "moonrise"
        case moonset = "moonset"
        case moonphase = "moonPhase"
        case moonillum = "moonIllum"
        case moonage = "moonAge"
        case all = "all"
        case allmoon = "allMoon"
        case allsun = "allSun"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of astronomy data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeDaysDateGet(latitude: Float, longitude: Float, date: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateGet? = nil, completion: @escaping ((_ data: AstronomyPointDayObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeDaysDateGetWithRequestBuilder(latitude: latitude, longitude: longitude, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of astronomy data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+0000",
    "dateEnd" : "2019-12-20T00:00:00.000+0000"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "astronomy" : [ {
    "date" : "2019-12-20T00:00:00.000+0000",
    "moonset" : "2019-12-20T13:25:07-05:00",
    "sunDistance" : 91455570,
    "sunrise" : "2019-12-20T07:22:27-05:00",
    "sunTransit" : "2019-12-20T12:05:41-05:00",
    "nauticalSet" : "2019-12-20T17:52:22-05:00",
    "moonIllum" : 38.24,
    "moonRadius" : 0.27,
    "astroSet" : "2019-12-20T18:24:49-05:00",
    "civilRise" : "2019-12-20T06:52:29-05:00",
    "moonrise" : "2019-12-20T01:08:09-05:00",
    "moonDistance" : 226632.73,
    "nauticalRise" : "2019-12-20T06:19:00-05:00",
    "sunRadius" : 0.26,
    "sunset" : "2019-12-20T16:48:55-05:00",
    "civilSet" : "2019-12-20T17:18:53-05:00",
    "astroRise" : "2019-12-20T05:46:33-05:00",
    "moonPhase" : "Waning Crescent",
    "moonAge" : 23.26
  }, {
    "date" : "2019-12-20T00:00:00.000+0000",
    "moonset" : "2019-12-20T13:25:07-05:00",
    "sunDistance" : 91455570,
    "sunrise" : "2019-12-20T07:22:27-05:00",
    "sunTransit" : "2019-12-20T12:05:41-05:00",
    "nauticalSet" : "2019-12-20T17:52:22-05:00",
    "moonIllum" : 38.24,
    "moonRadius" : 0.27,
    "astroSet" : "2019-12-20T18:24:49-05:00",
    "civilRise" : "2019-12-20T06:52:29-05:00",
    "moonrise" : "2019-12-20T01:08:09-05:00",
    "moonDistance" : 226632.73,
    "nauticalRise" : "2019-12-20T06:19:00-05:00",
    "sunRadius" : 0.26,
    "sunset" : "2019-12-20T16:48:55-05:00",
    "civilSet" : "2019-12-20T17:18:53-05:00",
    "astroRise" : "2019-12-20T05:46:33-05:00",
    "moonPhase" : "Waning Crescent",
    "moonAge" : 23.26
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "sunDistance" : "Miles",
      "sunRadius" : "Radial Degrees",
      "sunTransit" : "Timestamp as string: RFC 3339",
      "sunrise" : "Timestamp as string: RFC 3339",
      "sunset" : "Timestamp as string: RFC 3339",
      "civilRise" : "Timestamp as string: RFC 3339",
      "civilSet" : "Timestamp as string: RFC 3339",
      "nauticalRise" : "Timestamp as string: RFC 3339",
      "nauticalSet" : "Timestamp as string: RFC 3339",
      "astroRise" : "Timestamp as string: RFC 3339",
      "astroSet" : "Timestamp as string: RFC 3339",
      "moonDistance" : "Miles",
      "moonRadius" : "Radial Degrees",
      "moonrise" : "Timestamp as string: RFC 3339",
      "moonset" : "Timestamp as string: RFC 3339",
      "moonPhase" : "Phase of moon as string",
      "moonIllum" : "Percent value in [0,100]",
      "moonAge" : "Count of days"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<AstronomyPointDayObj> 
     */
    open class func pointsLatitudelongitudeDaysDateGetWithRequestBuilder(latitude: Float, longitude: Float, date: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateGet? = nil) -> RequestBuilder<AstronomyPointDayObj> {
        var path = "/points/{latitude},{longitude}/days/{date}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<AstronomyPointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeDaysDateStartdateEndGet: String { 
        case sundistance = "sunDistance"
        case sunradius = "sunRadius"
        case suntransit = "sunTransit"
        case sunrise = "sunrise"
        case sunset = "sunset"
        case civilrise = "civilRise"
        case civilset = "civilSet"
        case nauticalrise = "nauticalRise"
        case nauticalset = "nauticalSet"
        case astrorise = "astroRise"
        case astroset = "astroSet"
        case moondistance = "moonDistance"
        case moonradius = "moonRadius"
        case moonrise = "moonrise"
        case moonset = "moonset"
        case moonphase = "moonPhase"
        case moonillum = "moonIllum"
        case moonage = "moonAge"
        case all = "all"
        case allmoon = "allMoon"
        case allsun = "allSun"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily astronomy for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeDaysDateStartdateEndGet(latitude: Float, longitude: Float, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: AstronomyPointDayObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeDaysDateStartdateEndGetWithRequestBuilder(latitude: latitude, longitude: longitude, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily astronomy for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+0000",
    "dateEnd" : "2019-12-20T00:00:00.000+0000"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "astronomy" : [ {
    "date" : "2019-12-20T00:00:00.000+0000",
    "moonset" : "2019-12-20T13:25:07-05:00",
    "sunDistance" : 91455570,
    "sunrise" : "2019-12-20T07:22:27-05:00",
    "sunTransit" : "2019-12-20T12:05:41-05:00",
    "nauticalSet" : "2019-12-20T17:52:22-05:00",
    "moonIllum" : 38.24,
    "moonRadius" : 0.27,
    "astroSet" : "2019-12-20T18:24:49-05:00",
    "civilRise" : "2019-12-20T06:52:29-05:00",
    "moonrise" : "2019-12-20T01:08:09-05:00",
    "moonDistance" : 226632.73,
    "nauticalRise" : "2019-12-20T06:19:00-05:00",
    "sunRadius" : 0.26,
    "sunset" : "2019-12-20T16:48:55-05:00",
    "civilSet" : "2019-12-20T17:18:53-05:00",
    "astroRise" : "2019-12-20T05:46:33-05:00",
    "moonPhase" : "Waning Crescent",
    "moonAge" : 23.26
  }, {
    "date" : "2019-12-20T00:00:00.000+0000",
    "moonset" : "2019-12-20T13:25:07-05:00",
    "sunDistance" : 91455570,
    "sunrise" : "2019-12-20T07:22:27-05:00",
    "sunTransit" : "2019-12-20T12:05:41-05:00",
    "nauticalSet" : "2019-12-20T17:52:22-05:00",
    "moonIllum" : 38.24,
    "moonRadius" : 0.27,
    "astroSet" : "2019-12-20T18:24:49-05:00",
    "civilRise" : "2019-12-20T06:52:29-05:00",
    "moonrise" : "2019-12-20T01:08:09-05:00",
    "moonDistance" : 226632.73,
    "nauticalRise" : "2019-12-20T06:19:00-05:00",
    "sunRadius" : 0.26,
    "sunset" : "2019-12-20T16:48:55-05:00",
    "civilSet" : "2019-12-20T17:18:53-05:00",
    "astroRise" : "2019-12-20T05:46:33-05:00",
    "moonPhase" : "Waning Crescent",
    "moonAge" : 23.26
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "sunDistance" : "Miles",
      "sunRadius" : "Radial Degrees",
      "sunTransit" : "Timestamp as string: RFC 3339",
      "sunrise" : "Timestamp as string: RFC 3339",
      "sunset" : "Timestamp as string: RFC 3339",
      "civilRise" : "Timestamp as string: RFC 3339",
      "civilSet" : "Timestamp as string: RFC 3339",
      "nauticalRise" : "Timestamp as string: RFC 3339",
      "nauticalSet" : "Timestamp as string: RFC 3339",
      "astroRise" : "Timestamp as string: RFC 3339",
      "astroSet" : "Timestamp as string: RFC 3339",
      "moonDistance" : "Miles",
      "moonRadius" : "Radial Degrees",
      "moonrise" : "Timestamp as string: RFC 3339",
      "moonset" : "Timestamp as string: RFC 3339",
      "moonPhase" : "Phase of moon as string",
      "moonIllum" : "Percent value in [0,100]",
      "moonAge" : "Count of days"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<AstronomyPointDayObj> 
     */
    open class func pointsLatitudelongitudeDaysDateStartdateEndGetWithRequestBuilder(latitude: Float, longitude: Float, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet? = nil) -> RequestBuilder<AstronomyPointDayObj> {
        var path = "/points/{latitude},{longitude}/days/{dateStart},{dateEnd}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<AstronomyPointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHoursTimestampGet: String { 
        case sundistance = "sunDistance"
        case sunradius = "sunRadius"
        case sunazimuth = "sunAzimuth"
        case sunelevation = "sunElevation"
        case moondistance = "moonDistance"
        case moonradius = "moonRadius"
        case moonazimuth = "moonAzimuth"
        case moonelevation = "moonElevation"
        case moonphase = "moonPhase"
        case moonillum = "moonIllum"
        case moonage = "moonAge"
        case all = "all"
        case allmoon = "allMoon"
        case allsun = "allSun"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of astronomy data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHoursTimestampGet(latitude: Float, longitude: Float, timestamp: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampGet? = nil, completion: @escaping ((_ data: AstronomyPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHoursTimestampGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of astronomy data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "astronomy" : [ {
    "sunDistance" : 91455570,
    "sunAzimuth" : 354.91,
    "moonIllum" : 38.24,
    "sunRadius" : 0.26,
    "moonRadius" : 0.27,
    "moonElevation" : -12.23,
    "moonPhase" : "Waning Crescent",
    "SunElevation" : -74.51,
    "moonDistance" : 226632.73,
    "moonAge" : 23.26,
    "timestamp" : "2019-12-20T23:00:00-05:00",
    "moonAzimuth" : 79.28
  }, {
    "sunDistance" : 91455570,
    "sunAzimuth" : 354.91,
    "moonIllum" : 38.24,
    "sunRadius" : 0.26,
    "moonRadius" : 0.27,
    "moonElevation" : -12.23,
    "moonPhase" : "Waning Crescent",
    "SunElevation" : -74.51,
    "moonDistance" : 226632.73,
    "moonAge" : 23.26,
    "timestamp" : "2019-12-20T23:00:00-05:00",
    "moonAzimuth" : 79.28
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "sunDistance" : "Miles",
      "sunRadius" : "Radial Degrees",
      "sunAzimuth" : "Radial Degrees",
      "sunElevation" : "Radial Degrees",
      "moonDistance" : "Miles",
      "moonRadius" : "Radial Degrees",
      "moonAzimuth" : "Radial Degrees",
      "moonElevation" : "Radial Degrees",
      "moonPhase" : "Phase of moon as string",
      "moonIllum" : "Percent value in [0,100]",
      "moonAge" : "Count of days"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<AstronomyPointHourObj> 
     */
    open class func pointsLatitudelongitudeHoursTimestampGetWithRequestBuilder(latitude: Float, longitude: Float, timestamp: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampGet? = nil) -> RequestBuilder<AstronomyPointHourObj> {
        var path = "/points/{latitude},{longitude}/hours/{timestamp}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<AstronomyPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet: String { 
        case sundistance = "sunDistance"
        case sunradius = "sunRadius"
        case sunazimuth = "sunAzimuth"
        case sunelevation = "sunElevation"
        case moondistance = "moonDistance"
        case moonradius = "moonRadius"
        case moonazimuth = "moonAzimuth"
        case moonelevation = "moonElevation"
        case moonphase = "moonPhase"
        case moonillum = "moonIllum"
        case moonage = "moonAge"
        case all = "all"
        case allmoon = "allMoon"
        case allsun = "allSun"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly astronomy for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHoursTimestampStarttimestampEndGet(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: AstronomyPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly astronomy for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "astronomy" : [ {
    "sunDistance" : 91455570,
    "sunAzimuth" : 354.91,
    "moonIllum" : 38.24,
    "sunRadius" : 0.26,
    "moonRadius" : 0.27,
    "moonElevation" : -12.23,
    "moonPhase" : "Waning Crescent",
    "SunElevation" : -74.51,
    "moonDistance" : 226632.73,
    "moonAge" : 23.26,
    "timestamp" : "2019-12-20T23:00:00-05:00",
    "moonAzimuth" : 79.28
  }, {
    "sunDistance" : 91455570,
    "sunAzimuth" : 354.91,
    "moonIllum" : 38.24,
    "sunRadius" : 0.26,
    "moonRadius" : 0.27,
    "moonElevation" : -12.23,
    "moonPhase" : "Waning Crescent",
    "SunElevation" : -74.51,
    "moonDistance" : 226632.73,
    "moonAge" : 23.26,
    "timestamp" : "2019-12-20T23:00:00-05:00",
    "moonAzimuth" : 79.28
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "sunDistance" : "Miles",
      "sunRadius" : "Radial Degrees",
      "sunAzimuth" : "Radial Degrees",
      "sunElevation" : "Radial Degrees",
      "moonDistance" : "Miles",
      "moonRadius" : "Radial Degrees",
      "moonAzimuth" : "Radial Degrees",
      "moonElevation" : "Radial Degrees",
      "moonPhase" : "Phase of moon as string",
      "moonIllum" : "Percent value in [0,100]",
      "moonAge" : "Count of days"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allMoon *(moon related fields)* * allSun *(sun related fields)* * popular *(sunrise, sunset, moonrise, moonset, and moonPhase)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<AstronomyPointHourObj> 
     */
    open class func pointsLatitudelongitudeHoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<AstronomyPointHourObj> {
        var path = "/points/{latitude},{longitude}/hours/{timestampStart},{timestampEnd}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<AstronomyPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
